Index: /trunk/sources/HeuristicLab.LinearRegression/3.2/LinearRegression.cs
===================================================================
--- /trunk/sources/HeuristicLab.LinearRegression/3.2/LinearRegression.cs	(revision 2221)
+++ /trunk/sources/HeuristicLab.LinearRegression/3.2/LinearRegression.cs	(revision 2222)
@@ -34,4 +34,5 @@
 using HeuristicLab.GP;
 using HeuristicLab.Random;
+using HeuristicLab.GP.Interfaces;
 
 namespace HeuristicLab.LinearRegression {
@@ -281,5 +282,5 @@
       model.TestVarianceAccountedFor = bestModelScope.GetVariableValue<DoubleData>("TestVAF", false).Data;
 
-      model.Data = bestModelScope.GetVariableValue<IFunctionTree>("LinearRegressionModel", false);
+      model.Data = bestModelScope.GetVariableValue<IGeneticProgrammingModel>("LinearRegressionModel", false);
       HeuristicLab.DataAnalysis.Dataset ds = bestModelScope.GetVariableValue<Dataset>("Dataset", true);
       model.Dataset = ds;
Index: /trunk/sources/HeuristicLab.LinearRegression/3.2/LinearRegressionOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.LinearRegression/3.2/LinearRegressionOperator.cs	(revision 2221)
+++ /trunk/sources/HeuristicLab.LinearRegression/3.2/LinearRegressionOperator.cs	(revision 2222)
@@ -28,4 +28,5 @@
 using HeuristicLab.GP;
 using HeuristicLab.GP.StructureIdentification;
+using HeuristicLab.GP.Interfaces;
 
 namespace HeuristicLab.LinearRegression {
@@ -38,7 +39,5 @@
       AddVariableInfo(new VariableInfo("SamplesStart", "Start index of samples in dataset to evaluate", typeof(IntData), VariableKind.In));
       AddVariableInfo(new VariableInfo("SamplesEnd", "End index of samples in dataset to evaluate", typeof(IntData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("LinearRegressionModel", "Formula that was calculated by linear regression", typeof(IFunctionTree), VariableKind.Out | VariableKind.New));
-      AddVariableInfo(new VariableInfo("TreeSize", "The size (number of nodes) of the tree", typeof(IntData), VariableKind.New | VariableKind.Out));
-      AddVariableInfo(new VariableInfo("TreeHeight", "The height of the tree", typeof(IntData), VariableKind.New | VariableKind.Out));
+      AddVariableInfo(new VariableInfo("LinearRegressionModel", "Formula that was calculated by linear regression", typeof(IGeneticProgrammingModel), VariableKind.Out | VariableKind.New));
     }
 
@@ -54,9 +53,7 @@
       double[] targetVector = PrepareTargetVector(dataset, targetVariable, allowedRows);
       double[] coefficients = CalculateCoefficients(inputMatrix, targetVector);
-      IFunctionTree tree = CreateModel(coefficients, allowedColumns);
-
-      scope.AddVariable(new HeuristicLab.Core.Variable(scope.TranslateName("LinearRegressionModel"), tree));
-      scope.AddVariable(new HeuristicLab.Core.Variable(scope.TranslateName("TreeSize"), new IntData(tree.Size)));
-      scope.AddVariable(new HeuristicLab.Core.Variable(scope.TranslateName("TreeHeight"), new IntData(tree.Height)));
+      IFunctionTree tree = CreateModel(coefficients, allowedColumns.Select(i => dataset.GetVariableName(i)).ToList());
+      
+      scope.AddVariable(new HeuristicLab.Core.Variable(scope.TranslateName("LinearRegressionModel"), new GeneticProgrammingModel(tree)));
       return null;
     }
@@ -66,5 +63,5 @@
     }
 
-    private IFunctionTree CreateModel(double[] coefficients, List<int> allowedColumns) {
+    private IFunctionTree CreateModel(double[] coefficients, List<string> allowedVariables) {
       IFunctionTree root = new Addition().GetTreeNode();
       IFunctionTree actNode = root;
@@ -73,13 +70,14 @@
       GP.StructureIdentification.Variable v;
       for (int i = 0; i < coefficients.Length - 1; i++) {
-        v = new GP.StructureIdentification.Variable();
-        v.GetVariable(GP.StructureIdentification.Variable.INDEX).Value = new ConstrainedIntData(allowedColumns[i]);
-        v.GetVariable(GP.StructureIdentification.Variable.WEIGHT).Value = new ConstrainedDoubleData(coefficients[i]);
-        v.GetVariable(GP.StructureIdentification.Variable.OFFSET).Value = new ConstrainedIntData(0);
-        nodes.Enqueue(v.GetTreeNode());
+        var vNode = (VariableFunctionTree)new GP.StructureIdentification.Variable().GetTreeNode();
+        vNode.VariableName = allowedVariables[i];
+        vNode.Weight = coefficients[i];
+        vNode.SampleOffset = 0;
+        nodes.Enqueue(vNode);
       }
-      GP.StructureIdentification.Constant c = new Constant();
-      c.GetVariable(GP.StructureIdentification.Constant.VALUE).Value = new ConstrainedDoubleData(coefficients[coefficients.Length - 1]);
-      nodes.Enqueue(c.GetTreeNode());
+      var cNode = (ConstantFunctionTree)new Constant().GetTreeNode();
+
+      cNode.Value = coefficients[coefficients.Length - 1];
+      nodes.Enqueue(cNode);
 
       IFunctionTree newTree;
Index: /trunk/sources/HeuristicLab.Modeling/3.2/HeuristicLabModelingPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling/3.2/HeuristicLabModelingPlugin.cs	(revision 2221)
+++ /trunk/sources/HeuristicLab.Modeling/3.2/HeuristicLabModelingPlugin.cs	(revision 2222)
@@ -25,5 +25,5 @@
 using HeuristicLab.PluginInfrastructure;
 
-namespace HeuristicLab.GP.StructureIdentification {
+namespace HeuristicLab.GP.Modeling {
   [ClassInfo(Name = "HeuristicLab.Modeling-3.2")]
   [PluginFile(Filename = "HeuristicLab.Modeling-3.2.dll", Filetype = PluginFileType.Assembly)]
Index: /trunk/sources/HeuristicLab.Random/3.2/NormalDistributedRandom.cs
===================================================================
--- /trunk/sources/HeuristicLab.Random/3.2/NormalDistributedRandom.cs	(revision 2221)
+++ /trunk/sources/HeuristicLab.Random/3.2/NormalDistributedRandom.cs	(revision 2222)
@@ -55,5 +55,5 @@
     }
     private IRandom uniform;
-    private double[] w = new double[] {
+    private static readonly double[] w = new double[] {
       1.7290404664e-09,
       1.2680928529e-10,
@@ -185,5 +185,5 @@
       1.6030947680e-09
     };
-    private long[] k = new long[] {
+    private static readonly long[] k = new long[] {
       1991057938,
       0,
@@ -315,5 +315,5 @@
       2010539237
    };
-    private double[] f = new double[] {
+    private static readonly double[] f = new double[] {
       1.0000000000e+00,
       9.6359968185e-01,
Index: /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SupportVectorRegression.cs
===================================================================
--- /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SupportVectorRegression.cs	(revision 2221)
+++ /trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SupportVectorRegression.cs	(revision 2222)
@@ -30,5 +30,4 @@
 using HeuristicLab.Data;
 using HeuristicLab.Operators;
-using HeuristicLab.GP.StructureIdentification;
 using HeuristicLab.Logging;
 using HeuristicLab.Operators.Programmable;
Index: /trunk/sources/HeuristicLab.sln
===================================================================
--- /trunk/sources/HeuristicLab.sln	(revision 2221)
+++ /trunk/sources/HeuristicLab.sln	(revision 2222)
@@ -235,4 +235,8 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.LinearRegression-3.2", "HeuristicLab.LinearRegression\3.2\HeuristicLab.LinearRegression-3.2.csproj", "{B9A64475-D542-47CF-9688-735F6224F055}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.GP.Interfaces-3.3", "HeuristicLab.GP.Interfaces\3.3\HeuristicLab.GP.Interfaces-3.3.csproj", "{924B6BEA-9A99-40FE-9334-5C01E8D540EC}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.GP.Operators-3.3", "HeuristicLab.GP.Operators\3.3\HeuristicLab.GP.Operators-3.3.csproj", "{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}"
 EndProject
 Global
@@ -922,4 +926,5 @@
 		{7DD3A97A-56E9-462F-90E2-A351FE7AF5C2}.Modeling Debug|x64.Build.0 = Debug|x64
 		{7DD3A97A-56E9-462F-90E2-A351FE7AF5C2}.Modeling Debug|x86.ActiveCfg = Debug|x86
+		{7DD3A97A-56E9-462F-90E2-A351FE7AF5C2}.Modeling Debug|x86.Build.0 = Debug|x86
 		{7DD3A97A-56E9-462F-90E2-A351FE7AF5C2}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{7DD3A97A-56E9-462F-90E2-A351FE7AF5C2}.Release|Any CPU.Build.0 = Release|Any CPU
@@ -3736,6 +3741,8 @@
 		{B9A64475-D542-47CF-9688-735F6224F055}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{B9A64475-D542-47CF-9688-735F6224F055}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
-		{B9A64475-D542-47CF-9688-735F6224F055}.CEDMA Debug|x64.ActiveCfg = Debug|Any CPU
-		{B9A64475-D542-47CF-9688-735F6224F055}.CEDMA Debug|x86.ActiveCfg = Debug|Any CPU
+		{B9A64475-D542-47CF-9688-735F6224F055}.CEDMA Debug|x64.ActiveCfg = Debug|x64
+		{B9A64475-D542-47CF-9688-735F6224F055}.CEDMA Debug|x64.Build.0 = Debug|x64
+		{B9A64475-D542-47CF-9688-735F6224F055}.CEDMA Debug|x86.ActiveCfg = Debug|x86
+		{B9A64475-D542-47CF-9688-735F6224F055}.CEDMA Debug|x86.Build.0 = Debug|x86
 		{B9A64475-D542-47CF-9688-735F6224F055}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{B9A64475-D542-47CF-9688-735F6224F055}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3767,4 +3774,72 @@
 		{B9A64475-D542-47CF-9688-735F6224F055}.Visualization Debug|x86.ActiveCfg = Debug|x86
 		{B9A64475-D542-47CF-9688-735F6224F055}.Visualization Debug|x86.Build.0 = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.CEDMA Debug|x64.ActiveCfg = Debug|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.CEDMA Debug|x64.Build.0 = Debug|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.CEDMA Debug|x86.ActiveCfg = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.CEDMA Debug|x86.Build.0 = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Debug|x64.ActiveCfg = Debug|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Debug|x64.Build.0 = Debug|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Debug|x86.ActiveCfg = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Debug|x86.Build.0 = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Modeling Debug|x64.ActiveCfg = Debug|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Modeling Debug|x64.Build.0 = Debug|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Modeling Debug|x86.ActiveCfg = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Modeling Debug|x86.Build.0 = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Release|Any CPU.Build.0 = Release|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Release|x64.ActiveCfg = Release|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Release|x64.Build.0 = Release|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Release|x86.ActiveCfg = Release|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Release|x86.Build.0 = Release|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.v3.2 Debug|x64.ActiveCfg = Debug|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.v3.2 Debug|x64.Build.0 = Debug|x64
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.v3.2 Debug|x86.ActiveCfg = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.v3.2 Debug|x86.Build.0 = Debug|x86
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.CEDMA Debug|x64.ActiveCfg = Debug|x64
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.CEDMA Debug|x64.Build.0 = Debug|x64
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.CEDMA Debug|x86.ActiveCfg = Debug|x86
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.CEDMA Debug|x86.Build.0 = Debug|x86
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Debug|x64.ActiveCfg = Debug|x64
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Debug|x64.Build.0 = Debug|x64
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Debug|x86.ActiveCfg = Debug|x86
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Debug|x86.Build.0 = Debug|x86
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Modeling Debug|x64.ActiveCfg = Debug|x64
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Modeling Debug|x64.Build.0 = Debug|x64
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Modeling Debug|x86.ActiveCfg = Debug|x86
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Modeling Debug|x86.Build.0 = Debug|x86
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Release|Any CPU.Build.0 = Release|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Release|x64.ActiveCfg = Release|x64
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Release|x64.Build.0 = Release|x64
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Release|x86.ActiveCfg = Release|x86
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Release|x86.Build.0 = Release|x86
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.v3.2 Debug|x64.ActiveCfg = Debug|x64
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.v3.2 Debug|x64.Build.0 = Debug|x64
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.v3.2 Debug|x86.ActiveCfg = Debug|x86
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.v3.2 Debug|x86.Build.0 = Debug|x86
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
@@ -3853,4 +3928,6 @@
 		{C75532C4-765B-418E-B09B-46D36B2ABDB1} = {410732DB-725A-4824-896B-C298978343C0}
 		{B9A64475-D542-47CF-9688-735F6224F055} = {410732DB-725A-4824-896B-C298978343C0}
+		{924B6BEA-9A99-40FE-9334-5C01E8D540EC} = {410732DB-725A-4824-896B-C298978343C0}
+		{45D11FBD-A71B-48D3-8A94-8EB0DFE8E06A} = {410732DB-725A-4824-896B-C298978343C0}
 		{A9E282EA-180F-4233-B809-AEDF0787545C} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
Index: /trunk/sources/HeuristicLab/CopyAssemblies.cmd
===================================================================
--- /trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 2221)
+++ /trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 2222)
@@ -42,4 +42,6 @@
 copy "%SolutionDir%\HeuristicLab.GP\3.3\%Outdir%\HeuristicLab.GP-3.3.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.GP\3.4\%Outdir%\HeuristicLab.GP-3.4.dll" .\plugins
+copy "%SolutionDir%\HeuristicLab.GP.Interfaces\3.3\%Outdir%\HeuristicLab.GP.Interfaces-3.3.dll" .\plugins
+copy "%SolutionDir%\HeuristicLab.GP.Operators\3.3\%Outdir%\HeuristicLab.GP.Operators-3.3.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.GP.Boolean\3.3\%Outdir%\HeuristicLab.GP.Boolean-3.3.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.GP.SantaFe\3.3\%Outdir%\HeuristicLab.GP.SantaFe-3.3.dll" .\plugins
